import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopOrderGoods, ShopOrderGoodsParam } from './model';

/**
 * 分页查询商品信息
 */
export async function pageShopOrderGoods(params: ShopOrderGoodsParam) {
  const res = await request.get<ApiResult<PageResult<ShopOrderGoods>>>(
    '/shop/shop-order-goods/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商品信息列表
 */
export async function listShopOrderGoods(params?: ShopOrderGoodsParam) {
  const res = await request.get<ApiResult<ShopOrderGoods[]>>(
    '/shop/shop-order-goods',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商品信息
 */
export async function addShopOrderGoods(data: ShopOrderGoods) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-order-goods',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商品信息
 */
export async function updateShopOrderGoods(data: ShopOrderGoods) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-order-goods',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商品信息
 */
export async function removeShopOrderGoods(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-order-goods/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商品信息
 */
export async function removeBatchShopOrderGoods(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-order-goods/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商品信息
 */
export async function getShopOrderGoods(id: number) {
  const res = await request.get<ApiResult<ShopOrderGoods>>(
    '/shop/shop-order-goods/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
